/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var loggedIn = false;
var vivefanBaseURL = 'https://www.appsmlikes.com/api';
var vivefanServiceURL = null;
var movistarLikesLoginURL = "https://www.appsmlikes.com/likes/login.html";
var inAppBrowserRegistered = false;
//var vivefanBaseURL = 'https://www.vivefantelefonica.com/api';
//var vivefanBaseURL = 'https://vivefan.fontventa.com/api';

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    generateRandomIdentifier: function() {
        var characters = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890";
        var result = "";
        for (var i = 0; i < 200; ++i) {
            result += characters[Math.floor(Math.random() * characters.length)];
        }
        return result;
    },

    loginLikes: function(username, password) {

        $.ajax(vivefanBaseURL + '/version').done(function(result) {
            vivefanServiceURL = result.ServiceURL;
        });

        // Generamos un identificador al azar.
        var identifierLogin = app.generateRandomIdentifier();
        var identifierWindow = null;
        var intervalLogin = null;
        var params = "";
        if (username != null) {
            params += "&username=" + encodeURIComponent(username);
        }
        if (password != null) {
            params += "&password=" + encodeURIComponent(password);
        }

        // Ejecutamos el InAppBrowser con la página de Login de MovistarLikes enviando el identificador de login.
        if (inAppBrowserRegistered) {
            identifierWindow = window.open(movistarLikesLoginURL + "?requestId=" + identifierLogin + params, "_blank", "directories=no,titlebar=no,toolbar=no,location=no,status=no,menubar=no,scrollbars=no");
        } else {
            identifierWindow = window.open(movistarLikesLoginURL + "?requestId=" + identifierLogin + params, "_blank", "resizable=yes, scrollbars=yes, titlebar=yes, width=640, height=480, top=10, left=10");
        }

        intervalLogin = setInterval(function() {
            if (vivefanServiceURL != null) {
                $.ajax(vivefanServiceURL + "/temprequests/load", {
                    method: "POST",
                    contentType: "application/json",
                    data: JSON.stringify({
                        RequestId: identifierLogin
                    })
                }).done(function(res) {
                    if (!res.Error.HasError) {
                        var content = res.content;
                        identifierWindow.close();
                        $("#btnLogin").hide();
                        $("#btnNoLogin").hide();
                        $("#btnLikes").hide();
                        $("#cargandoVivefan").show();
                        clearInterval(intervalLogin);
                        var objLogin = JSON.parse(content);
                        var username = objLogin.username;
                        var password = objLogin.password;
                        var userId = objLogin.userId;
                        var token = objLogin.token;
                        localStorage.setItem("username", username);
                        localStorage.setItem("password", password);
                        localStorage.setItem("autologin", "likes");
                        loggedIn = true;

                        // Si es Android cargamos en un iFrame para habilitar el botón Back, si es iOS en un iFrame no funciona el ViewPort así que cargamos en la propia ventana.
                        var deviceType = (navigator.userAgent.match(/iPad/i))  == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i))  == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
                        if (deviceType == 'Android') {
                            var iFrameGame = document.createElement("iframe");
                            iFrameGame.setAttribute("style", "width:480px; height:100%; position:fixed; z-index:999; border:0; margin:0; top: 0; left: 0; background-color: black;");
                            document.body.style.backgroundColor = '#000000';
                            document.body.appendChild(iFrameGame);
                            iFrameGame.setAttribute("src", "https://www.appsmlikes.com/chapas?cordova=true&token=" + encodeURIComponent(token) + "&userId=" + encodeURIComponent(userId) + "&username=" + encodeURIComponent(username) + "&password=" + encodeURIComponent(password) + "&loginType=likes");
                        } else {
                            window.open("https://www.appsmlikes.com/chapas?cordova=true&token=" + encodeURIComponent(token) + "&userId=" + encodeURIComponent(userId) + "&username=" + encodeURIComponent(username) + "&password=" + encodeURIComponent(password) + "&loginType=likes", "_self");
                        }

                    }
                })
            }
        }, 5000);

    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {

        if (typeof(cordova) != 'undefined' && cordova.InAppBrowser != null && cordova.InAppBrowser.open != null) {
            window.open = cordova.InAppBrowser.open;
            inAppBrowserRegistered = true;
        }

        $(".app").show();
        localStorage.setItem("dispositivoViveFan", JSON.stringify(device));
        app.receivedEvent('deviceready');
        document.addEventListener("backbutton", app.onBackKeyDown, false);

        if (localStorage.getItem("autologin") != null && localStorage.getItem("autologin") != "") {
            if (localStorage.getItem("autologin") == "fb") {
                if (localStorage.getItem("token") != null && localStorage.getItem("userId") != null) {
                    $("#btnLogin").hide();
                    $("#btnNoLogin").hide();
                    $("#btnLikes").hide();
                    $("#cargandoVivefan").show();

                    $.ajax("https://graph.facebook.com/me?access_token=" + localStorage.getItem("token")).done(function(data) {
                        var result;
                        try {
                            result = JSON.parse(data);
                        } catch (ex) {
                            result = data;
                        }
                        if (result.error != null) {
                            $("#btnLogin").show();
                            $("#btnNoLogin").show();
                            $("#btnLikes").show();
                            $("#cargandoVivefan").hide();
                        } else {
                            loggedIn = true;
                            runApp(localStorage.getItem("token"), localStorage.getItem("userId"));
                        }
                    }).fail(function(err) {
                        $("#btnLogin").show();
                        $("#btnNoLogin").show();
                        $("#btnLikes").show();
                        $("#cargandoVivefan").hide();
                    });

                }
            }
            if (localStorage.getItem("autologin") == "likes") {
                app.loginLikes(localStorage.getItem("username"), localStorage.getItem("password"));
            }
        }
    },
    onBackKeyDown: function() {
        if (loggedIn) {
            navigator.notification.confirm(decodeURIComponent("%C2%BFQuieres salir del juego?"), function(result) {
                if (result == 1) {
                    navigator.app.exitApp();
                }
            }, "Salir", decodeURIComponent("S%C3%AD,No"));
        } else {
            navigator.app.exitApp();
        }
    },

// Update DOM on a Received Event
    receivedEvent: function(id) {
        /*var parentElement = document.getElementById(id);
        var listeningElement = parentElement.querySelector('.listening');
        var receivedElement = parentElement.querySelector('.received');

        listeningElement.setAttribute('style', 'display:none;');
        receivedElement.setAttribute('style', 'display:block;');*/
        $("#btnNoLogin").show();
        $("#btnLikes").show();

        console.log('Received Event: ' + id);
    }
};

app.initialize();

var runApp = function(token, userId) {
    // Si es Android cargamos en un iFrame para habilitar el botón Back, si es iOS en un iFrame no funciona el ViewPort así que cargamos en la propia ventana.
    var deviceType = (navigator.userAgent.match(/iPad/i))  == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i))  == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
    if (deviceType == 'Android') {
        var iFrameGame = document.createElement("iframe");
        iFrameGame.setAttribute("style", "width:480px; height:100%; position:fixed; z-index:999; border:0; margin:0; top: 0; left: 0; background-color: black;");
        document.body.style.backgroundColor = '#000000';
        document.body.appendChild(iFrameGame);
        iFrameGame.setAttribute("src", "https://www.appsmlikes.com/chapas?cordova=true&token=" + encodeURIComponent(token) + "&fbUserId=" + encodeURIComponent(userId));
    } else {
        window.open(document.location.href = "https://www.appsmlikes.com/chapas?cordova=true&token=" + encodeURIComponent(token) + "&fbUserId=" + encodeURIComponent(userId), "_self");
    }
};

$("#btnNoLogin").click(function() {
    localStorage.setItem("token", "NO");
    localStorage.setItem("userId", "NO");
    localStorage.setItem("autologin", "NO");
    runApp("NO", "NO");
});


$("#btnLogin").click(function() {
    $("#btnLogin").hide();
    $("#btnNoLogin").hide();
    $("#btnLikes").hide();
    facebookConnectPlugin.login(["email","user_friends","public_profile"], function(result) {
        loggedIn = true;

        var token = result.authResponse.accessToken;
        var userId = result.authResponse.userID;

        // Verificamos si tenemos que utilizar la API nueva o la antigua.
        $.ajax(vivefanBaseURL + '/version').done(function(result) {

            if (result.NuevaApi == false) {

                // Llamamos a la API de Vivefan
                $.ajax(vivefanBaseURL + '/user', {
                    method: "POST",
                    data: {
                        userType: "facebook",
                        fbId: userId,
                        accessToken: token,
                        timezone: jstz.determine().name()
                    }
                }).done(function (result) {
                    localStorage.setItem("autologin", "fb");
                    localStorage.setItem("token", token);
                    localStorage.setItem("userId", userId);

                    runApp(token, userId);
                }).fail(function (err) {
                    localStorage.setItem("autologin", "fb");
                    localStorage.setItem("token", token);
                    localStorage.setItem("userId", userId);

                    runApp(token, userId);
                });

            } else {
                // Si es la nueva API el usuario lo creará automáticamente
                localStorage.setItem("autologin", "fb");
                localStorage.setItem("token", token);
                localStorage.setItem("userId", userId);
                runApp(token, userId);
            }

        }).fail(function(err) {
            runApp(token, userId);
        });

        var token = result.authResponse.accessToken;
        var userId = result.authResponse.userID;

        /*var iFrameGame = document.createElement("iframe");
        iFrameGame.setAttribute("style", "width:100%; height:100%; position:fixed; z-index:999; border:0; margin:0;");
        document.body.appendChild(iFrameGame);
        iFrameGame.setAttribute("src", "http://vivefan.fontventa.com/chapas?cordova=true&token=" + encodeURIComponent(token) + "&fbUserId=" + encodeURIComponent(userId));*/
    }, function(err) {
        $("#btnLogin").show();
        $("#btnNoLogin").show();
        $("#btnLikes").show();
        navigator.notification.alert(decodeURIComponent("El inicio de sesi%C3%B3n ha fallado. Int%C3%A9ntalo de nuevo m%C3%A1s tarde."), null, "Login", "Aceptar");
    });
});

$("#btnLikes").click(function() {
    app.loginLikes(null, null);
});
